-- Perimiter at (x)
function Pa()
  return macalc.rcl(1)
end

function Pb()
  return macalc.rcl(2)
end

function Ph()
  return macalc.rcl(3)
end

function F()
  return Pb()-Ph()
end

function a(x)
  return sqrt(Pa()^2-(Pa()^2*(F()+x)^2/Pb()^2))
end

function b(x)
  return sqrt(Pb()^2-(F()+x)^2)
end

function lua_main(x)
  -- Cache level a and b
  a = a(x)
  b = b(x)
  -- Set slices and delta angle
  slices = 1000
  d = pi/2/slices
  -- Set iterator and perimiter
  i = 0
  p = 0

  repeat
    -- Set coordinates
    ax = a*cos(d*i)
    ay = b*sin(d*i)
    bx = a*cos(d*(i+1))
    by = b*sin(d*(i+1))

    -- Calculate distance
    dst = sqrt((ax-bx)^2+(ay-by)^2)

    -- Add up perimiter and increment iterator
    p = p + dst
    i = i +1

  until i>=slices

  -- Multiply by four to get total perimeter
  return p*4
end
